#include <hecuba/HecubaSession.h>
#include <hecuba/IStorage.h>
#include <iostream>
using namespace std;

Hecuba_exporter::Hecuba_exporter(int _a, int _b): a(_a), b(_b){
   // TODO: Add the hecuba session as class member
  char * key;
  char * value;
  char * numpymeta;

  try {

    cout << "C++ side: creating Hecuba connection....." << endl;
    s.loadDataModel("DUMMYMODELFILE.MDL");
    std::cout<< "+ Data Model loaded"<<std::endl;

    IStorage* midict = s.createObject("dataModel", "yoli");
    std::cout<< "+ 'dict' object created"<<std::endl;

    key = generateKey(0.5, 0);
    std::cout<< "+  key created"<<std::endl;
    numpymeta = generateMetas();
    std::cout<< "+ metadata created"<<std::endl;
    value = generateNumpyContent();
    std::cout<< "+ value created at "<<std::hex<<(void*)value<<std::endl;

    // midict[key] = value;
    midict->setItem((void*)key, (void*) value, NULL, (void*) numpymeta);
  } catch (std::exception &e) {
    std::cerr << "Error running the test " << std::endl;
    std::cerr << e.what() << std::endl;
    //free resources
    free(key);
    free(numpymeta);
    free(value);
    throw e;
  }

  free(key);
  free(numpymeta);
  free(value);
}

Hecuba_exporter::~Hecuba_exporter(){
    cout << "C++ side: chauuuuuuuuuuuuuuuuuu" << endl;
}

double Hecuba_exporter::load_datamodel(double d) const{
    //save data into database
    return d + b;
}
